/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package application.graphics;

import application.graphics.bottom.InfoArea;
import application.graphics.center.Panel;
import application.graphics.controls.ControlsArea;
import javafx.event.ActionEvent;
import javafx.event.Event;
import javafx.event.EventHandler;
import javafx.scene.input.KeyCode;
import javafx.scene.input.KeyEvent;
import javafx.scene.layout.BorderPane;

/**
 *
 * @author sci-esame
 */
public class Gui extends BorderPane {

    Panel centerPanel;

    /**
     * Classe che rappresenta il Parent principale di tutta l'applicazione
     */
    public Gui() {
        drawCenter();
        drawTop();
        drawBottom();
        this.setOnKeyPressed(new EventHandler<KeyEvent>() {

            @Override
            public void handle(KeyEvent event) {
                if (event.getCode().equals(KeyCode.S)) {
                    Event.fireEvent(ControlsArea.print, new ActionEvent());
                } else if (event.getCode().equals(KeyCode.N)) {
                    Event.fireEvent(ControlsArea.reset, new ActionEvent());
                }
            }
        });
    }

    private void drawTop() {
        ControlsArea ca = new ControlsArea(centerPanel);
        this.setTop(ca);
    }

    private void drawBottom() {
        InfoArea info = new InfoArea();
        this.setBottom(info);
    }

    private void drawCenter() {
        centerPanel = new Panel(this);
        this.setCenter(centerPanel);
    }

}
