/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package application.graphics.center;

import application.graphics.center.faces.Face;
import application.graphics.center.faces.Face1;
import application.graphics.center.faces.Face2;
import application.graphics.center.faces.Face3;
import application.graphics.center.faces.Face4;
import application.graphics.center.faces.Face5;
import application.graphics.center.faces.Face6;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.Pane;
import javafx.scene.layout.Region;
import javafx.scene.paint.Color;
import javafx.scene.shape.Rectangle;
import javafx.scene.shape.StrokeType;

/**
 *
 * @author sci-esame
 */
public class Dado extends Pane {

    Face fc;
    int value;
    Region parent;

    /**
     * Dimensione del dado
     */
    public static final double dimension = 50;

    private final double circleDimension = 5;

    /**
     * Costruttore del dato
     *
     * @param parent Il Region dove il dado sarà inserito
     * @param event L'evento che permette di posizionare il dado correttamente
     */
    public Dado(Region parent, MouseEvent event) {
        this.parent = parent;
        backGround();
        position(event);

        this.setWidth(dimension);
        this.setHeight(dimension);

        createFace(randomValue());
        this.getChildren().add(fc);

    }

    @Override
    public String toString() {
        return "Valore = " + value;
    }

    private void backGround() {
        Rectangle rec = new Rectangle();

        rec.setStrokeType(StrokeType.INSIDE);
        rec.setStroke(Color.BLACK);

        rec.widthProperty().bind(this.widthProperty());
        rec.heightProperty().bind(this.heightProperty());

        rec.setFill(Color.WHITE);

        this.getChildren().add(rec);
    }

    private void position(MouseEvent event) {
        this.setTranslateX(event.getX() - dimension / 2.0);
        this.setTranslateY(event.getY() - dimension / 2.0);

    }

    private static int randomValue() {
        int value = (int) (Math.random() * 7);
        if (value < 1) {
            value = 1;
        }
        return value;
    }

    private void createFace(int value) {

        this.value = value;

        switch (value) {
            case 1:
                fc = new Face1(1, circleDimension);
                break;
            case 2:
                fc = new Face2(2, circleDimension);
                break;
            case 3:
                fc = new Face3(3, circleDimension);
                break;
            case 4:
                fc = new Face4(4, circleDimension);
                break;
            case 5:
                fc = new Face5(5, circleDimension);
                break;
            case 6:
                fc = new Face6(6, circleDimension);
                break;
        }
    }

    void newFace() {

        this.getChildren().remove(1);

        int newValue = randomValue();
        createFace(newValue);

        this.getChildren().add(fc);

    }

    /**
     *
     * @return
     */
    public int getValue() {
        return this.value;
    }
}
