/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package application.graphics.controls;

import application.graphics.center.Panel;
import javafx.beans.value.ChangeListener;
import javafx.beans.value.ObservableValue;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.geometry.Insets;
import javafx.geometry.Pos;
import javafx.scene.control.Button;
import javafx.scene.control.ToggleButton;
import javafx.scene.layout.ColumnConstraints;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.VBox;

/**
 *
 * @author sci-esame
 */
public class ControlsArea extends GridPane {

    ToggleButton mode = new ToggleButton("Spostamento");
    Panel centerPanel;
    public static Button print = new Button("Stampa");
    public static Button reset = new Button("Nuova Partita");

    /**
     * Area superiore con i bottoni di controllo
     *
     * @param p Il pannello centrale dei dadi
     */
    public ControlsArea(Panel p) {
        this.centerPanel = p;

        this.setPadding(new Insets(5));
        this.setAlignment(Pos.CENTER);
        columns();
        mainButtons();
    }

    private void mainButtons() {
        VBox resetBox = new VBox(5);
        resetBox.setAlignment(Pos.CENTER);

        setupToogle();

        reset.setOnAction(new EventHandler<ActionEvent>() {

            @Override
            public void handle(ActionEvent event) {
                centerPanel.reset();
            }
        });
        print.setOnAction(new EventHandler<ActionEvent>() {

            @Override
            public void handle(ActionEvent event) {
                new LoggerWindow();
            }
        });

        resetBox.getChildren().addAll(reset, mode);

        this.add(resetBox, 0, 0);
        this.add(print, 1, 0);
    }

    private void columns() {
        ColumnConstraints cc = new ColumnConstraints();
        ColumnConstraints cc1 = new ColumnConstraints();

        cc.setPercentWidth(50);
        cc1.setPercentWidth(50);

        this.getColumnConstraints().addAll(cc, cc1);
    }

    private void setupToogle() {
        mode.selectedProperty().addListener(new ChangeListener<Boolean>() {

            @Override
            public void changed(ObservableValue<? extends Boolean> observable, Boolean oldValue, Boolean newValue) {
                if (newValue.booleanValue()) {
                    mode.setText("Dissolvimento");
                } else {
                    mode.setText("Spostamento");
                }
            }
        });
    }

}
